searchData={"content_type":"text/markdown","items":[{"doc":"CharsetDetect is a simple wrapper around the chardetng crate.","ref":"CharsetDetect.html","title":"CharsetDetect","type":"module"},{"doc":"Guess the encoding of a string.","ref":"CharsetDetect.html#guess/1","title":"CharsetDetect.guess/1","type":"function"},{"doc":"iex> File.read!(\"test/assets/sjis.txt\") |> CharsetDetect.guess\n    {:ok, \"Shift_JIS\"}","ref":"CharsetDetect.html#guess/1-examples","title":"Examples - CharsetDetect.guess/1","type":"function"},{"doc":"Guess the encoding of a string (exceptional).","ref":"CharsetDetect.html#guess!/1","title":"CharsetDetect.guess!/1","type":"function"},{"doc":"iex> File.read!(\"test/assets/big5.txt\") |> CharsetDetect.guess!\n    \"Big5\"","ref":"CharsetDetect.html#guess!/1-examples","title":"Examples - CharsetDetect.guess!/1","type":"function"},{"doc":"🌏 CharsetDetect: Guess character encoding\n==========================================\n\n[![Hex.pm](https://img.shields.io/hexpm/v/charset_detect.svg)](https://hex.pm/packages/charset_detect)\n[![Hexdocs.pm](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/charset_detect/)\n[![Hex.pm](https://img.shields.io/hexpm/dt/charset_detect.svg)](https://hex.pm/packages/charset_detect)\n[![License](https://img.shields.io/hexpm/l/charset_detect.svg)](https://github.com/ryochin/charset_detect/blob/main/LICENSE)\n\nCharsetDetect is a simple wrapper around the [chardetng](https://crates.io/crates/chardetng) crate.\n\nUsage\n-----\n\nGuess the encoding of a string:\n\n```elixir\niex> File.read!(\"test/assets/sjis.txt\") |> CharsetDetect.guess\n{:ok, \"Shift_JIS\"}\n\niex> File.read!(\"test/assets/big5.txt\") |> CharsetDetect.guess!\n\"Big5\"\n```\n\nYou might consider minimizing additional memory consumption.\n\n```elixir\niex> \"... (long text) ...\" |> String.slice(0, 1024) |> CharsetDetect.guess\n```\n\nNote that an ASCII string, including an empty string, will result in a `UTF-8` encoding rather than `ASCII`.\n\n```elixir\niex> \"hello world\" |> CharsetDetect.guess\n{:ok, \"UTF-8\"}\n```\n\nStrategies for implementing a conversion function\n-------------------------------------------------\n\nYou can achieve conversion to any desired encoding using [iconv](https://hex.pm/packages/iconv).\n\n```elixir\ndefmodule Converter do\n  @spec convert(binary, String.t()) :: {:ok, binary} | {:error, String.t()}\n  def convert(text, to_encoding \\\\ \"UTF-8\") do\n    case text |> String.slice(0, 1024) |> CharsetDetect.guess do\n      {:ok, ^to_encoding} ->\n        {:ok, text}\n      {:ok, encoding} ->\n        try do\n          {:ok, :iconv.convert(encoding, to_encoding, text)}\n        rescue\n          e in ArgumentError -> {:error, inspect(e)}\n        end\n      {:error, reason} ->\n        {:error, reason}\n    end\n  end\nend\n```\n```elixir\niex> File.read!(\"test/assets/big5.txt\") |> Converter.convert\n{:ok, \"大五碼是繁体中文（正體中文）社群最常用的電腦漢字字符集標準。\\n\"}\n```\n\nInstallation\n------------\n\nThe package can be installed by adding `charset_detect` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:charset_detect, \"~> 0.1.0\"}\n  ]\nend\n```\n\nThen, run `mix deps.get`.\n\nDevelopment\n-----------","ref":"readme.html","title":"🌏 CharsetDetect: Guess character encoding","type":"extras"},{"doc":"**Note:** This library requires the [Rust](https://www.rust-lang.org/) Toolchain for compilation.\n\nFollow the instructions at [www.rust-lang.org/tools/install](https://www.rust-lang.org/tools/install) to install Rust.\n\nVerify the installation by checking the `cargo` command version:\n\n```sh\ncargo --version\n# Should output something like: cargo 1.82.0 (8f40fc59f 2024-08-21)\n```\n\nThen, set the `RUSTLER_PRECOMPILATION_EXAMPLE_BUILD` environment variable to ensure that local sources are compiled instead of downloading a precompiled library file.\n\n```sh\nRUSTLER_PRECOMPILATION_EXAMPLE_BUILD=1 mix compile\n```\n\nLicense\n-------\n\nThe MIT License","ref":"readme.html#prerequisites","title":"Prerequisites - 🌏 CharsetDetect: Guess character encoding","type":"extras"}],"producer":{"name":"ex_doc","version":"0.36.1"},"proglang":"elixir"}